#define MIDI_NOTEON  0x90
#define MIDI_NOTEOFF 0x80
#define MIDI_AFTERTOUCH 0xA0
#define MIDI_CC 0xB0
#define MIDI_CHANPRESSURE 0xD0
#define MIDI_PITCHWHEEL 0xE0
#define MIDI_SONGPOSITION 0xF2
#define MIDI_START 0xFA
#define MIDI_CONTINUE 0xFB
#define MIDI_STOP 0xFC
#define MIDI_SYSEX_START 0xF0
#define MIDI_SYSEX_FINISH 0xF7

#define MIDI_IDLE 0
#define MIDI_READSYSEX 1
#define MIDI_SYSEXDONE 2

#define MIDI_MANUF_ID 0x7D // 'educational use'

#define SYSEX_MAX_LEN 64

void note_on(uint8_t addr, uint8_t note, uint8_t vel);
void note_off(uint8_t addr, uint8_t note, uint8_t vel);
uint8_t read_midiaddr(void);
int midi_getchar(void);
int midi_getch(void);
void sendmidicc(uint8_t addr, uint8_t controller, uint8_t data);
void midi_send_sysex_str(const char *str);
void midi_send_sysex_num(uint8_t i);
void midi_send_sysex(void);

uint8_t calc_CRC7(uint8_t *buff, uint8_t size);
